diff --git a/game/client/setup_bg.sh b/game/client/setup_bg.sh
old mode 100644
new mode 100755
index 25860dba5..539400af7
--- a/game/client/setup_bg.sh
+++ b/game/client/setup_bg.sh
@@ -3,7 +3,7 @@
 ROOT_DIR=./src/main/resources/bg
 
 for filename in "${ROOT_DIR}"/*.png; do
-    if ! magick identify "${filename}" | grep "512x256" > /dev/null; then
+    if ! magick identify "${filename}" | grep "1024x512" > /dev/null; then
         echo "${filename}"
         magick "${filename}" \
             -define filter:blur=3 \
@@ -11,9 +11,9 @@ for filename in "${ROOT_DIR}"/*.png; do
             -define png:format=png24 \
             -define png:compression-strategy=3 \
             -filter Lagrange \
-            -resize 512 \
+            -resize 1024 \
             -gravity center \
-            -crop 512x256+0+0 \
+            -crop 1024x512+0+0 \
             +repage \
             "${filename}"
     fi
diff --git a/game/client/src/main/java/net/minecraft/client/Minecraft.java b/game/client/src/main/java/net/minecraft/client/Minecraft.java
index eeffad659..d19a667a5 100644
--- a/game/client/src/main/java/net/minecraft/client/Minecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/Minecraft.java
@@ -146,8 +146,6 @@ import net.minecraft.core.world.save.LevelStorage;
 import net.minecraft.core.world.save.SaveConverters;
 import net.minecraft.core.world.save.SaveFormatBase;
 import net.minecraft.core.world.save.SaveFormats;
-import net.minecraft.core.world.save.mcregion.SaveFormat19134;
-import net.minecraft.core.world.save.mcregion.SaveFormat19135;
 import net.minecraft.core.world.settings.WorldConfiguration;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -480,7 +478,10 @@ public class Minecraft
 
         this.resolution.setScale(GameSettings.GUI_SCALE.value);
 
-        SaveFormatBase handlerBase = new SaveFormat19135(new File(this.mcDataDir, "saves"));
+        ISaveFormat activeFormat = SaveFormats.createSaveFormat(CURRENT_SAVE_VERSION, new File(this.mcDataDir, "saves"));
+        if (!(activeFormat instanceof SaveFormatBase handlerBase)) {
+            throw new IllegalStateException("No save format registered for current save version " + CURRENT_SAVE_VERSION);
+        }
         handlerBase.factory = LevelStorageClientSP::new;
         this.saveFormat = handlerBase;
         I18n.initialize(GameSettings.LANGUAGE.value);
@@ -2180,42 +2181,67 @@ public class Minecraft
     }
 
     private void convertSaveVersion(int fromVersion, String worldDirName) {
-        ISaveFormat fromWorldFormat = SaveFormats.createSaveFormat(fromVersion, new File(this.mcDataDir, "saves"));
+        int currentVersion = fromVersion;
+        while (currentVersion < CURRENT_SAVE_VERSION) {
+            ISaveFormat fromWorldFormat = SaveFormats.createSaveFormat(currentVersion, new File(this.mcDataDir, "saves"));
+            if (fromWorldFormat == null) {
+                break;
+            }
 
-        if (fromWorldFormat != null) {
-            // Get highest converter
             ISaveConverter converterToUse = null;
             for (ISaveConverter converter : SaveConverters.saveConverters) {
-                if (converter.fromVersion() == fromVersion) {
+                if (converter.fromVersion() == currentVersion) {
                     if (converterToUse == null || converter.toVersion() > converterToUse.toVersion()) {
                         converterToUse = converter;
                     }
                 }
             }
+            if (converterToUse == null) {
+                break;
+            }
+            if (converterToUse.toVersion() <= currentVersion) {
+                LOGGER.warn("World conversion halted for '{}' due to non-advancing converter {} -> {}.", worldDirName, converterToUse.fromVersion(), converterToUse.toVersion());
+                break;
+            }
 
-            if (converterToUse != null) {
-                ISaveFormat toWorldFormat = SaveFormats.createSaveFormat(converterToUse.toVersion(), new File(this.mcDataDir, "saves"));
-
-                if (toWorldFormat != null) {
-                    this.loadingScreen.updateLoadingBackground(null);
-                    this.loadingScreen.progressStartNoAbort("Converting world from " + fromWorldFormat.getFormatName() + " to " + toWorldFormat.getFormatName() + ".");
-                    this.loadingScreen.progressStage("This may take a while :)");
+            ISaveFormat toWorldFormat = SaveFormats.createSaveFormat(converterToUse.toVersion(), new File(this.mcDataDir, "saves"));
+            if (toWorldFormat == null) {
+                break;
+            }
 
-                    CompoundTag levelDataTag = toWorldFormat.getLevelDataRaw(worldDirName);
+            this.loadingScreen.updateLoadingBackground(null);
+            this.loadingScreen.progressStartNoAbort("Converting world from " + fromWorldFormat.getFormatName() + " to " + toWorldFormat.getFormatName() + ".");
+            String formatMessage = toWorldFormat.getFormatMessage();
+            this.loadingScreen.progressStage((formatMessage == null || formatMessage.isEmpty()) ? "This may take a while :)" : formatMessage);
 
-                    converterToUse.convertSave(levelDataTag, new File(this.mcDataDir, "saves"), worldDirName, this.loadingScreen);
+            CompoundTag levelDataTag = toWorldFormat.getLevelDataRaw(worldDirName);
+            converterToUse.convertSave(levelDataTag, new File(this.mcDataDir, "saves"), worldDirName, this.loadingScreen);
+            this.loadingScreen.progressStop();
 
-                    this.loadingScreen.progressStop();
+            levelDataTag.putInt("version", toWorldFormat.getSaveVersion());
+            LevelStorage saveHandler = toWorldFormat.getLevelStorage(worldDirName, false);
+            saveHandler.saveLevelDataRaw(levelDataTag);
 
-                    levelDataTag.putInt("version", toWorldFormat.getSaveVersion());
+            CompoundTag reloadedLevelData = toWorldFormat.getLevelDataRaw(worldDirName);
+            int reloadedVersion = reloadedLevelData != null ? reloadedLevelData.getInteger("version") : -1;
+            if (reloadedVersion < toWorldFormat.getSaveVersion()) {
+                LOGGER.warn("World conversion write verification failed for '{}' (expected >= {}, got {}).", worldDirName, toWorldFormat.getSaveVersion(), reloadedVersion);
+                break;
+            }
 
-                    LevelStorage saveHandler = toWorldFormat.getLevelStorage(worldDirName, false);
-                    saveHandler.saveLevelDataRaw(levelDataTag);
+            currentVersion = reloadedVersion;
+        }
 
-                    startWorld(worldDirName);
-                }
+        ISaveFormat currentFormat = SaveFormats.createSaveFormat(CURRENT_SAVE_VERSION, new File(this.mcDataDir, "saves"));
+        if (currentFormat != null) {
+            CompoundTag finalLevelData = currentFormat.getLevelDataRaw(worldDirName);
+            if (finalLevelData != null && finalLevelData.getInteger("version") < CURRENT_SAVE_VERSION) {
+                finalLevelData.putInt("version", CURRENT_SAVE_VERSION);
+                currentFormat.getLevelStorage(worldDirName, false).saveLevelDataRaw(finalLevelData);
             }
         }
+
+        startWorld(worldDirName);
     }
 
     private void prepareLevel(String loadingTitle) {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenHudEditor.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenHudEditor.java
index 39e559808..4a63e1bb0 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenHudEditor.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenHudEditor.java
@@ -444,9 +444,12 @@ public class ScreenHudEditor extends Screen {
         drawHudComponents(mx, my);
 
         if (this.heldComponent != null && this.isDragging) {
+            int padding = (int) GameSettings.SCREEN_PADDING.value.floatValue();
+            int usableWidth = Math.max(1, this.width - padding * 2);
+            int usableHeight = Math.max(1, this.height - padding * 2);
             for (ComponentAnchor anchor : ComponentAnchor.values()) {
                 if (anchor == ComponentAnchor.CENTER) continue;
-                drawAnchor(0, 0, (int) (this.width * anchor.xPosition), (int) (this.height * anchor.yPosition), anchor);
+                drawAnchor(padding, padding, (int) (usableWidth * anchor.xPosition), (int) (usableHeight * anchor.yPosition), anchor);
             }
         }
 
@@ -579,13 +582,20 @@ public class ScreenHudEditor extends Screen {
         int ySize = this.heldComponent.getDisplayedYSize();
         int xOffset = this.heldComponent.getDisplayedAnchorX(this.heldAnchor);
         int yOffset = this.heldComponent.getDisplayedAnchorY(this.heldAnchor);
-        int newX = MathHelper.clamp(mouseX, xOffset, this.width - (xSize - xOffset));
-        int newY = MathHelper.clamp(mouseY, yOffset, this.height - (ySize - yOffset));
+        int padding = (int) GameSettings.SCREEN_PADDING.value.floatValue();
+        int minX = xOffset + padding;
+        int maxX = this.width - padding - (xSize - xOffset);
+        int minY = yOffset + padding;
+        int maxY = this.height - padding - (ySize - yOffset);
+        int newX = MathHelper.clamp(mouseX, minX, Math.max(minX, maxX));
+        int newY = MathHelper.clamp(mouseY, minY, Math.max(minY, maxY));
 
         Layout layout = this.heldComponent.getLayout();
         if (layout instanceof LayoutAbsolute absoluteLayout) {
-            absoluteLayout.setXPosition((float) newX / this.width);
-            absoluteLayout.setYPosition((float) newY / this.height);
+            int usableWidth = Math.max(1, this.width - padding * 2);
+            int usableHeight = Math.max(1, this.height - padding * 2);
+            absoluteLayout.setXPosition((float) (newX - padding) / usableWidth);
+            absoluteLayout.setYPosition((float) (newY - padding) / usableHeight);
         }
 
         int snapRadius = 10;
@@ -638,7 +648,9 @@ public class ScreenHudEditor extends Screen {
             }
 
             if (!didSnap) {
-                LayoutAbsolute newLayout = new LayoutAbsolute((float) newX / this.width, (float) newY / this.height, this.heldAnchor);
+                int usableWidth = Math.max(1, this.width - padding * 2);
+                int usableHeight = Math.max(1, this.height - padding * 2);
+                LayoutAbsolute newLayout = new LayoutAbsolute((float) (newX - padding) / usableWidth, (float) (newY - padding) / usableHeight, this.heldAnchor);
                 ((HudComponentMovable) this.heldComponent).setLayout(newLayout);
                 this.snappedComponent = null;
                 this.snappedAnchor = null;
@@ -681,10 +693,13 @@ public class ScreenHudEditor extends Screen {
     private ComponentAnchor getScreenAnchorInRadius(int x, int y, int mouseX, int mouseY, int radius) {
         ComponentAnchor anchor = null;
         int minDistance = Integer.MAX_VALUE;
+        int padding = (int) GameSettings.SCREEN_PADDING.value.floatValue();
+        int usableWidth = Math.max(1, this.width - padding * 2);
+        int usableHeight = Math.max(1, this.height - padding * 2);
         for (ComponentAnchor componentAnchor : ComponentAnchor.values()) {
             if (componentAnchor == ComponentAnchor.CENTER) continue;
-            int xAnchor = (int) (componentAnchor.xPosition * this.width);
-            int yAnchor = (int) (componentAnchor.yPosition * this.height);
+            int xAnchor = padding + (int) (componentAnchor.xPosition * usableWidth);
+            int yAnchor = padding + (int) (componentAnchor.yPosition * usableHeight);
             int distance = (int) Math.sqrt(Math.pow(mouseX - (x + xAnchor), 2) + Math.pow(mouseY - (y + yAnchor), 2));
             if (distance < minDistance && distance <= radius) {
                 minDistance = distance;
@@ -720,7 +735,7 @@ public class ScreenHudEditor extends Screen {
             if (!component.isEnabled()) continue;
             Layout layout = component.getLayout();
             GLRenderer.pushFrame();
-            component.renderPreview(this, layout, this.width, this.height);
+            component.renderPreviewScaled(this, layout, this.width, this.height);
             GLRenderer.popFrame();
 
             if (component == this.selectedComponent && (!this.isDragging || component != this.heldComponent)) {
@@ -756,7 +771,7 @@ public class ScreenHudEditor extends Screen {
         if (this.heldComponent != null && this.isDragging) {
             Layout layout = this.heldComponent.getLayout();
             GLRenderer.pushFrame();
-            this.heldComponent.renderPreview(this, layout, this.width, this.height);
+            this.heldComponent.renderPreviewScaled(this, layout, this.width, this.height);
             GLRenderer.popFrame();
             int x = layout.getComponentX(this.heldComponent, this.width);
             int y = layout.getComponentY(this.heldComponent, this.height);
@@ -774,6 +789,13 @@ public class ScreenHudEditor extends Screen {
             int xAnchor = this.snappedComponent.getDisplayedAnchorX(this.snappedAnchor);
             int yAnchor = this.snappedComponent.getDisplayedAnchorY(this.snappedAnchor);
             drawAnchor(x, y, xAnchor, yAnchor, this.snappedAnchor);
+        } else if (this.heldComponent != null && this.isDragging && this.snappedAnchor != null) {
+            int padding = (int) GameSettings.SCREEN_PADDING.value.floatValue();
+            int usableWidth = Math.max(1, this.width - padding * 2);
+            int usableHeight = Math.max(1, this.height - padding * 2);
+            int xAnchor = (int) (this.snappedAnchor.xPosition * usableWidth);
+            int yAnchor = (int) (this.snappedAnchor.yPosition * usableHeight);
+            drawAnchor(padding, padding, xAnchor, yAnchor, this.snappedAnchor);
         }
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/chat/ScreenChat.java b/game/client/src/main/java/net/minecraft/client/gui/chat/ScreenChat.java
index 708b0f6d4..94e1074de 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/chat/ScreenChat.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/chat/ScreenChat.java
@@ -3,10 +3,12 @@ package net.minecraft.client.gui.chat;
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.gui.Screen;
 import net.minecraft.client.gui.hud.component.ComponentAnchor;
+import net.minecraft.client.gui.hud.component.HudComponents;
 import net.minecraft.client.gui.keyboard.ScreenKeyboard;
 import net.minecraft.client.gui.text.TextFieldEditor;
 import net.minecraft.client.input.InputType;
 import net.minecraft.client.option.GameSettings;
+import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.net.ChatEmotes;
 import org.lwjgl.input.Keyboard;
@@ -48,8 +50,8 @@ public class ScreenChat extends Screen implements ITextField {
                 this.mc,
                 this.editor,
 				this,
-				(parent, child, minecraft, followParameters) -> 16 + (followParameters ? this.suggestionsElement.getDefaultParameterPosition() - 1 : 0),
-				(parent, child, minecraft, followParameters) -> minecraft.resolution.getScaledHeightScreenCoords() - 14,
+				(parent, child, minecraft, followParameters) -> HudComponents.CHAT_INPUT.getLayout().getComponentX(HudComponents.CHAT_INPUT, minecraft.resolution.getScaledWidthScreenCoords()) + 14 + (followParameters ? this.suggestionsElement.getDefaultParameterPosition() - 1 : 0),
+				(parent, child, minecraft, followParameters) -> HudComponents.CHAT_INPUT.getLayout().getComponentY(HudComponents.CHAT_INPUT, minecraft.resolution.getScaledHeightScreenCoords()) - 2,
 				ComponentAnchor.BOTTOM_LEFT
 			);
 			if (!this.getText().startsWith("/")) {
@@ -80,7 +82,7 @@ public class ScreenChat extends Screen implements ITextField {
 	@Override
 	public void removed() {
 		Keyboard.enableRepeatEvents(false);
-        this.mc.hudIngame.chatScroll = 0;
+        HudComponents.CHAT.chatScroll = 0;
 	}
 
 	@Override
@@ -98,7 +100,7 @@ public class ScreenChat extends Screen implements ITextField {
 				if (this.showEmotePicker) {
                     this.emotePicker.scrollOffset((int)(-dWheel / 0.1f));
 				} else {
-                    this.mc.hudIngame.chatScroll += dWheel;
+                    HudComponents.CHAT.chatScroll += dWheel;
 				}
 			}
 
@@ -204,23 +206,41 @@ public class ScreenChat extends Screen implements ITextField {
 	@Override
 	public void render(int mx, int my, float partialTick) {
 		try {
+			int inputX = HudComponents.CHAT_INPUT.getLayout().getComponentX(HudComponents.CHAT_INPUT, this.width);
+			int inputY = HudComponents.CHAT_INPUT.getLayout().getComponentY(HudComponents.CHAT_INPUT, this.height);
+			float scale = HudComponents.CHAT_INPUT.getScale();
+			int boxWidth = HudComponents.CHAT_INPUT.getBaseXSize();
+
+			// Convert mouse coords to component-local (unscaled) space for hit-testing.
+			int localMx = unscaleX(mx, inputX, scale);
+			int localMy = unscaleY(my, inputY, scale);
+
 			// Draw emote picker button
 			int emotePickerButtonColor = 0x80000000;
 			int emotePickerTextColor = 0xE0E0E0;
-			if (mx >= 2 && mx < 14 && my >= this.height - 14 && my < this.height - 2)
+			if (localMx >= inputX && localMx < inputX + 12 && localMy >= inputY && localMy < inputY + 12)
 			{
 				emotePickerButtonColor = 0x80ffffff;
 				emotePickerTextColor = 0xffffffa0;
 			}
-			drawRect(2, this.height - 14, 14, this.height - 2, emotePickerButtonColor);
-			drawStringCenteredShadow(this.fontRenderer, Character.toString('\u263a'), 2 + 6, this.height - 12, emotePickerTextColor);
 
-			drawRect(16, this.height - 14, this.width - 2, this.height - 2, 0x80000000);
+			boolean scaled = scale != 1.0f;
+			if (scaled) {
+				GLRenderer.pushFrame();
+				GLRenderer.modelM4f().translate(inputX, inputY, 0.0f);
+				GLRenderer.modelM4f().scale(scale, scale, 1.0f);
+				GLRenderer.modelM4f().translate(-inputX, -inputY, 0.0f);
+			}
+
+			drawRect(inputX, inputY, inputX + 12, inputY + 12, emotePickerButtonColor);
+			drawStringCenteredShadow(this.fontRenderer, Character.toString('\u263a'), inputX + 6, inputY + 2, emotePickerTextColor);
+
+			drawRect(inputX + 14, inputY, inputX + boxWidth, inputY + 12, 0x80000000);
 
-			drawStringShadow(this.fontRenderer, this.suggestionsElement.getSuggestionPreview(), 16 + this.suggestionsElement.getDefaultParameterPosition(), this.mc.resolution.getScaledHeightScreenCoords() - 12, 0xFFFFFF);
+			drawStringShadow(this.fontRenderer, this.suggestionsElement.getSuggestionPreview(), inputX + 14 + this.suggestionsElement.getDefaultParameterPosition(), inputY + 2, 0xFFFFFF);
 			boolean drawCursor = (this.updateCounter / 6) % 2 == 0;
 			int cursor = this.editor.getCursor();
-			drawStringShadow(this.fontRenderer, this.suggestionsElement.colorCodeText(this.message, true), 18, this.height - 12, 0xE0E0E0);
+			drawStringShadow(this.fontRenderer, this.suggestionsElement.colorCodeText(this.message, true), inputX + 16, inputY + 2, 0xE0E0E0);
 			if (drawCursor)
 			{
 				int width = MathHelper.ceil(this.fontRenderer.stringWidthDouble(this.message));
@@ -228,11 +248,15 @@ public class ScreenChat extends Screen implements ITextField {
 				{
 					width = MathHelper.ceil(this.fontRenderer.stringWidthDouble(this.message.substring(0, cursor)));
 				}
-				drawStringShadow(this.fontRenderer, "_", 18 + width, this.height - 12, 0xE0E0E0);
+				drawStringShadow(this.fontRenderer, "_", inputX + 16 + width, inputY + 2, 0xE0E0E0);
 			}
 
 			if (this.showEmotePicker) {
-                this.emotePicker.draw(2, this.height - 16 - this.emotePicker.getHeight(), mx, my);
+                this.emotePicker.draw(inputX, inputY - 2 - this.emotePicker.getHeight(), localMx, localMy);
+			}
+
+			if (scaled) {
+				GLRenderer.popFrame();
 			}
 
 			super.render(mx, my, partialTick);
@@ -244,18 +268,34 @@ public class ScreenChat extends Screen implements ITextField {
 		}
 	}
 
+	private static int unscaleX(int screenX, int anchorX, float scale) {
+		if (scale == 1.0f) return screenX;
+		return Math.round(anchorX + (screenX - anchorX) / scale);
+	}
+
+	private static int unscaleY(int screenY, int anchorY, float scale) {
+		if (scale == 1.0f) return screenY;
+		return Math.round(anchorY + (screenY - anchorY) / scale);
+	}
+
 	@Override
 	public void mouseClicked(int mx, int my, int buttonNum) {
 		super.mouseClicked(mx, my, buttonNum);
 		try {
 			boolean handled = false;
 			if (buttonNum == 0) {
-				if (mx >= 2 && mx < 14 && my >= this.height - 14 && my < this.height - 2) {
+				int inputX = HudComponents.CHAT_INPUT.getLayout().getComponentX(HudComponents.CHAT_INPUT, this.width);
+				int inputY = HudComponents.CHAT_INPUT.getLayout().getComponentY(HudComponents.CHAT_INPUT, this.height);
+				float scale = HudComponents.CHAT_INPUT.getScale();
+				int localMx = unscaleX(mx, inputX, scale);
+				int localMy = unscaleY(my, inputY, scale);
+
+				if (localMx >= inputX && localMx < inputX + 12 && localMy >= inputY && localMy < inputY + 12) {
                     this.showEmotePicker = !this.showEmotePicker;
 					handled = true;
 				}
 				if (!handled && this.showEmotePicker) {
-					Character c = this.emotePicker.click(mx - 2, my - (this.height - 16 - this.emotePicker.getHeight()));
+					Character c = this.emotePicker.click(localMx - inputX, localMy - (inputY - 2 - this.emotePicker.getHeight()));
 					if (c != null) {
                         this.editor.handleInput(0, c);
 						if (!Keyboard.isKeyDown(Keyboard.KEY_LSHIFT) && !Keyboard.isKeyDown(Keyboard.KEY_RSHIFT))
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventory.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventory.java
index f2dc21dbc..e89aa4ef6 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventory.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventory.java
@@ -270,6 +270,7 @@ public class ScreenInventory extends ScreenContainerAbstract {
         float eyesY = (float) ((y + 75) - 50) - this.ySize_lo;
         GLRenderer.modelM4f().rotateY(org.joml.Math.toRadians(135F));
         Lighting.enableLight();
+        GLRenderer.setLightMapStrength(0f);
         GLRenderer.modelM4f().rotateY(org.joml.Math.toRadians(-135F));
         GLRenderer.modelM4f().rotateX(org.joml.Math.toRadians(-(float) Math.atan(eyesY / 40F) * 20F));
         this.mc.thePlayer.yBodyRotO = this.mc.thePlayer.yBodyRot = (float) Math.atan(eyesX / 40F) * 20F;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventoryCreative.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventoryCreative.java
index 79e1c3ed6..90b1e8cdb 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventoryCreative.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventoryCreative.java
@@ -12,6 +12,8 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.client.gui.options.OptionsButtonElement;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.player.inventory.menu.MenuInventoryCreative;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.Lighting;
 import net.minecraft.client.render.EntityRendererDispatcher;
 import org.jetbrains.annotations.NotNull;
@@ -47,12 +49,25 @@ public class ScreenInventoryCreative extends ScreenInventory implements ITextCha
         this.searchField.drawBackground = false;
         this.searchField.setMaxStringLength(14);
         this.searchField.setTextChangeListener(this);
+        this.applySavedCreativeInventoryPage();
         updatePageSwitcher();
         Keyboard.enableRepeatEvents(true);
     }
 
     public void scroll(int direction) {
-        if (direction == 0) return;
+        if (direction == 0) {
+            return;
+        }
+        final boolean shift = Keyboard.isKeyDown(Keyboard.KEY_LSHIFT) || Keyboard.isKeyDown(Keyboard.KEY_RSHIFT);
+        if (shift) {
+            if (direction > 0 && this.container.page > 0) {
+                this.container.jumpToFirstCreativePage();
+            } else if (direction < 0 && this.container.page < this.container.maxPage) {
+                this.container.jumpToLastCreativePage();
+            }
+            updatePageSwitcher();
+            return;
+        }
         int count = 1;
         if (Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL)) {
             count = 10;
@@ -62,24 +77,25 @@ public class ScreenInventoryCreative extends ScreenInventory implements ITextCha
         }
         while (this.lastPageButton.enabled && direction > 0 && count > 0) {
             this.container.lastPage();
-            updatePageSwitcher();
             count--;
         }
         while (this.nextPageButton.enabled && direction < 0 && count > 0) {
             this.container.nextPage();
-            updatePageSwitcher();
             count--;
         }
+        updatePageSwitcher();
     }
 
     @Override
     public void tick() {
         super.tick();
         this.searchField.updateCursorCounter();
+        this.updateCreativePageArrowLabels();
     }
 
     @Override
     public void removed() {
+        this.persistCreativeInventoryPage();
         super.removed();
         Keyboard.enableRepeatEvents(false);
     }
@@ -89,6 +105,26 @@ public class ScreenInventoryCreative extends ScreenInventory implements ITextCha
         this.nextPageButton.enabled = this.container.page != this.container.maxPage;
 
         this.pageString = (this.container.page + 1) + "/" + (this.container.maxPage + 1);
+        this.persistCreativeInventoryPage();
+    }
+
+    private void applySavedCreativeInventoryPage() {
+        final int saved = GameSettings.LAST_CREATIVE_INVENTORY_PAGE.value;
+        final int maxPage = this.container.maxPage;
+        final int clamped = MathHelper.clamp(saved, 0, maxPage);
+        if (clamped != saved) {
+            GameSettings.LAST_CREATIVE_INVENTORY_PAGE.set(clamped);
+            GameSettings.saveOptions();
+        }
+        this.container.setInventoryStatus(clamped, this.container.searchText);
+    }
+
+    private void persistCreativeInventoryPage() {
+        final int page = this.container.page;
+        if (page != GameSettings.LAST_CREATIVE_INVENTORY_PAGE.value) {
+            GameSettings.LAST_CREATIVE_INVENTORY_PAGE.set(page);
+            GameSettings.saveOptions();
+        }
     }
 
     @Override
@@ -99,9 +135,17 @@ public class ScreenInventoryCreative extends ScreenInventory implements ITextCha
         }
 
         if (button == this.lastPageButton) {
-            scroll(1);
+            if (Keyboard.isKeyDown(Keyboard.KEY_LSHIFT) || Keyboard.isKeyDown(Keyboard.KEY_RSHIFT)) {
+                this.container.jumpToFirstCreativePage();
+            } else {
+                scroll(1);
+            }
         } else if (button == this.nextPageButton) {
-            scroll(-1);
+            if (Keyboard.isKeyDown(Keyboard.KEY_LSHIFT) || Keyboard.isKeyDown(Keyboard.KEY_RSHIFT)) {
+                this.container.jumpToLastCreativePage();
+            } else {
+                scroll(-1);
+            }
         } else if (button == this.clearSearchButton) {
             if (Keyboard.isKeyDown(Keyboard.KEY_LSHIFT) || Keyboard.isKeyDown(Keyboard.KEY_RSHIFT)) {
                 for (int i = 0; i < this.container.inventory.getContainerSize() + this.container.craftSlots.getContainerSize() + this.container.resultSlots.getContainerSize(); i++) {
@@ -184,6 +228,7 @@ public class ScreenInventoryCreative extends ScreenInventory implements ITextCha
         float eyesY = (float) ((y + 75) - 50) - this.ySize_lo;
         GLRenderer.modelM4f().rotateY(org.joml.Math.toRadians(135F));
         Lighting.enableLight();
+        GLRenderer.setLightMapStrength(0f);
         GLRenderer.modelM4f().rotateY(org.joml.Math.toRadians(-135F));
         GLRenderer.modelM4f().rotateX(org.joml.Math.toRadians(-(float) Math.atan(eyesY / 40F) * 20F));
         this.mc.thePlayer.yBodyRotO = this.mc.thePlayer.yBodyRot = (float) Math.atan(eyesX / 40F) * 20F;
@@ -213,6 +258,12 @@ public class ScreenInventoryCreative extends ScreenInventory implements ITextCha
         updatePageSwitcher();
     }
 
+    private void updateCreativePageArrowLabels() {
+        final boolean shift = Keyboard.isKeyDown(Keyboard.KEY_LSHIFT) || Keyboard.isKeyDown(Keyboard.KEY_RSHIFT);
+        this.lastPageButton.displayString = shift ? "|<" : "<";
+        this.nextPageButton.displayString = shift ? ">|" : ">";
+    }
+
     @Override
     public void guiSpecificControllerInput(@NotNull ControllerInput controller) {
         if (controller.buttonLeftShoulder.pressedThisFrame()) {
